<link rel="import" href="../polymer/polymer-element.html">

<dom-module id="fotosocial-login">
  <template>
    <style>
      :host {
        display: block;
      }

      .container {
        display: flex;
        flex-direction: column;
        background-color: #F2F2F2;
        padding: 20px;
        border: 1px solid;
        @apply --fotosocial-login-container;
      }

      .button-container {
        display: flex;
        flex-direction: column;
        align-items: flex-end;
      }

      paper-button {
        width: 200px;
      }

      .invalid-user {
        color: red;
      }
    </style>
    <div class="container">
      <paper-input label="Usuario" value="{{user::input}}">
        <iron-icon icon="account-circle" slot="suffix"></iron-icon>
      </paper-input>
      <paper-input label="Contraseña" value="{{password::input}}" type="password">
        <iron-icon icon="lock" slot="suffix"></iron-icon>
      </paper-input>
      <div class="button-container">
        <div hidden$="[[invalidUser]]" class="invalid-user">Usuario Invalido</div>
        <paper-button disabled="[[loginDisabled]]" raised on-click="_clickLogin">
          Entrar
        </paper-button>
        <paper-button on-click="_goToRegister">
          Registrar
        </paper-button>
      </div>
    </div>
  </template>

  <script>
    /**
     * `fotosocial-login`
     * login del proyecto
     *
     * @customElement
     * @polymer
     * @demo demo/index.html
     */
    class FotosocialLogin extends Polymer.Element {
      static get is() { return 'fotosocial-login'; }
      static get properties() {
        return {
          user: {
            type: String,
            value: ''
          },
          password: {
            type: String,
            value: ''
          },
          loginDisabled: {
            type: Boolean,
            value: true,
            computed: '_validate(user, password)'
          },
          invalidUser: {
            type: Boolean,
            value: true
          }
        };
      }

      _validate(user, password) {
        return user !== '' && password !== '' ? false : true;
      }

      _goToRegister() {
        this.dispatchEvent(new CustomEvent('click-go-to-register',{
          bubbles: true,
          composed: true,
          detail: 'fotosocialRegister'
        }));
        this._reset();
      }

      _clickLogin() {
        this.set('invalidUser', true);
        this.dispatchEvent(new CustomEvent('click-login',{
          bubbles: true,
          composed: true,
          detail: {
            user: this.user,
            password: this.password
          }
        }));
        this._reset();
      }

      _reset() {
        this.set('user', '');
        this.set('password', '');
      }
    }

    window.customElements.define(FotosocialLogin.is, FotosocialLogin);
  </script>
</dom-module>
